<template>
  <ele-modal
    :width="520"
    :footer="null"
    title="商品图片批量导入"
    :visible="visible"
    @update:visible="updateVisible"
  >
    <a-spin :spinning="loading">
      <a-upload-dragger
        accept=".zip"
        :show-upload-list="false"
        :customRequest="doUpload"
        style="padding: 24px 0; margin-bottom: 16px"
      >
        <p class="ant-upload-drag-icon">
          <CloudUploadOutlined />
        </p>
        <p class="ant-upload-hint">将 zip 文件拖到此处，或点击上传</p>
      </a-upload-dragger>
    </a-spin>
    <div class="ele-text-center">
      <span>只能上传 zip 文件，图片文件名需与商品编号对应</span>
    </div>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref } from 'vue';
  import { message } from 'ant-design-vue/es';
  import { CloudUploadOutlined } from '@ant-design/icons-vue';
  import { importShopGoodsImages } from '@/api/shop/shopGoods';

  defineProps<{
    visible: boolean;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  const loading = ref(false);

  const doUpload = ({ file }) => {
    const isZip =
      file.type === 'application/zip' ||
      file.type === 'application/x-zip-compressed' ||
      file.name.endsWith('.zip');
    if (!isZip) {
      message.error('只能选择 zip 文件');
      return false;
    }
    if (file.size / 1024 / 1024 > 50) {
      message.error('大小不能超过 50MB');
      return false;
    }
    loading.value = true;
    importShopGoodsImages(file)
      .then((msg) => {
        loading.value = false;
        message.success(msg);
        updateVisible(false);
        emit('done');
      })
      .catch((e) => {
        loading.value = false;
        message.error(e.message);
      });
    return false;
  };

  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };
</script>
